# coding=utf-8
from django.dispatch import receiver

from concentrator.smev3.event_service.events import NEW_DIRECT_EVENT
from concentrator.smev3.event_service.helpers import get_event_data
from concentrator.smev3.event_service.tasks import CreateInfoEventTask
from kinder.core.declaration.enum import DeclarationSourceEnum
from kinder.core.declaration.models import DSS, Declaration
from kinder.core.declaration_status.signals import declaration_status_change


@receiver(declaration_status_change, sender=Declaration)
def declaration_status_changed_handler(
        declaration,
        user,
        old_status,
        commentary,
        is_auto,
        log_id,
        reject_reason_id,
        **kwargs
):
    """Обработка смены статуса заявки на "Направлен в ДОО"."""
    if declaration.source == DeclarationSourceEnum.CONCENTRATOR and (
            old_status != DSS.DIRECTED and
            declaration.status.code == DSS.DIRECTED):
        CreateInfoEventTask().apply_async(
            get_event_data(declaration, NEW_DIRECT_EVENT))
